(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/elements'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-el', ['exports', '@angular/core', '@angular/elements', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ngx-el"] = {}, global.ng.core, global.ng.elements, global.rxjs, global.rxjs.operators));
})(this, (function (exports, i0, elements, rxjs, operators) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        var desc = Object.getOwnPropertyDescriptor(m, k);
        if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
            desc = { enumerable: true, get: function () { return m[k]; } };
        }
        Object.defineProperty(o, k2, desc);
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }
    function __classPrivateFieldIn(state, receiver) {
        if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
            throw new TypeError("Cannot use 'in' operator on non-object");
        return typeof state === "function" ? receiver === state : state.has(receiver);
    }

    /* Injection token to provide the element path modules. */
    var LAZY_CMPS_PATH_TOKEN = new i0.InjectionToken('ngx-lazy-cmp-registry');

    var NgxElementService = /** @class */ (function () {
        function NgxElementService(modulePaths, compiler, injector) {
            this.compiler = compiler;
            this.injector = injector;
            this.loadedComponents = new Map();
            this.elementsLoading = new Map();
            this.injectors = new Map();
            this.componentFactoryResolvers = new Map();
            var ELEMENT_MODULE_PATHS = new Map();
            modulePaths.forEach(function (route) {
                ELEMENT_MODULE_PATHS.set(route.selector, route);
            });
            this.componentsToLoad = ELEMENT_MODULE_PATHS;
        }
        NgxElementService.prototype.receiveContext = function (component, injector) {
            this.injectors.set(component, injector);
            this.componentFactoryResolvers.set(component, injector.get(i0.ComponentFactoryResolver));
        };
        NgxElementService.prototype.getInjector = function (component) {
            return this.injectors.get(component);
        };
        NgxElementService.prototype.getComponentFactoryResolver = function (component) {
            return this.componentFactoryResolvers.get(component);
        };
        NgxElementService.prototype.getComponentsToLoad = function () {
            return this.componentsToLoad;
        };
        NgxElementService.prototype.getComponentToLoad = function (selector) {
            // Returns observable that completes when the lazy module has been loaded.
            var registered = this.loadComponent(selector);
            return rxjs.from(registered);
        };
        /**
         * Allows to lazy load a component given its selector.
         * If the component selector has been registered, it's according module
         * will be fetched lazily
         * @param componentTag selector of the component to load
         */
        NgxElementService.prototype.loadComponent = function (componentSelector) {
            var _this = this;
            if (this.elementsLoading.has(componentSelector)) {
                return this.elementsLoading.get(componentSelector);
            }
            if (this.componentsToLoad.has(componentSelector)) {
                var cmpRegistryEntry = this.componentsToLoad.get(componentSelector);
                var path_1 = cmpRegistryEntry.loadChildren;
                var loadPromise = new Promise(function (resolve, reject) {
                    path_1()
                        .then(function (elementModuleOrFactory) {
                        /**
                         * With View Engine, the NgModule factory is created and provided when loaded.
                         * With Ivy, only the NgModule class is provided loaded and must be compiled.
                         * This uses the same mechanism as the deprecated `SystemJsNgModuleLoader` in
                         * in `packages/core/src/linker/system_js_ng_module_factory_loader.ts`
                         * to pass on the NgModuleFactory, or compile the NgModule and return its NgModuleFactory.
                         */
                        if (elementModuleOrFactory instanceof i0.NgModuleFactory) {
                            return elementModuleOrFactory;
                        }
                        else {
                            try {
                                return _this.compiler.compileModuleAsync(elementModuleOrFactory);
                            }
                            catch (err) {
                                // return the error
                                reject(err);
                                // break the promise chain
                                throw err;
                            }
                        }
                    })
                        .then(function (moduleFactory) {
                        var elementModuleRef = moduleFactory.create(_this.injector);
                        var componentClass;
                        if (typeof elementModuleRef.instance.customElementComponent === 'object') {
                            componentClass = elementModuleRef.instance.customElementComponent[componentSelector];
                            if (!componentClass) {
                                // tslint:disable-next-line: no-string-throw
                                throw "You specified multiple component elements in module " + elementModuleRef + " but there was no match for tag\n                        " + componentSelector + " in " + JSON.stringify(elementModuleRef.instance.customElementComponent) + ".\n                         Make sure the selector in the module is aligned with the one specified in the lazy module definition.";
                            }
                        }
                        else {
                            componentClass = elementModuleRef.instance.customElementComponent;
                        }
                        // Register injector of the lazy module.
                        // This is needed to share the entryComponents between the lazy module and the application
                        var moduleInjector = elementModuleRef.injector;
                        _this.receiveContext(componentClass, moduleInjector);
                        _this.loadedComponents.set(componentSelector, componentClass);
                        _this.elementsLoading.delete(componentSelector);
                        _this.componentsToLoad.delete(componentSelector);
                        resolve({
                            selector: componentSelector,
                            componentClass: componentClass
                        });
                    })
                        .catch(function (err) {
                        _this.elementsLoading.delete(componentSelector);
                        return Promise.reject(err);
                    });
                });
                this.elementsLoading.set(componentSelector, loadPromise);
                return loadPromise;
            }
            else if (this.loadedComponents.has(componentSelector)) {
                // component already loaded
                return new Promise(function (resolve) {
                    resolve({
                        selector: componentSelector,
                        componentClass: _this.loadedComponents.get(componentSelector)
                    });
                });
            }
            else {
                throw new Error("Unrecognized component \"" + componentSelector + "\". Make sure it is registered in the component registry");
            }
        };
        return NgxElementService;
    }());
    NgxElementService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxElementService, deps: [{ token: LAZY_CMPS_PATH_TOKEN }, { token: i0__namespace.Compiler }, { token: i0__namespace.Injector }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    NgxElementService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxElementService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxElementService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [LAZY_CMPS_PATH_TOKEN]
                        }] }, { type: i0__namespace.Compiler }, { type: i0__namespace.Injector }];
        } });

    var NgxElementComponent = /** @class */ (function () {
        function NgxElementComponent(ngxElementService, elementRef) {
            this.ngxElementService = ngxElementService;
            this.elementRef = elementRef;
        }
        /**
         * Subscribe to event emitters of a lazy loaded and dynamically instantiated Angular component
         * and dispatch them as Custom Events on the NgxElementComponent that is used in a template.
         */
        NgxElementComponent.prototype.setProxiedOutputs = function (factory) {
            var _this = this;
            var eventEmitters = factory.outputs.map(function (_a) {
                var propName = _a.propName, templateName = _a.templateName;
                var emitter = _this.componentRef.instance[propName];
                return emitter.pipe(operators.map(function (value) { return ({ name: templateName, value: value }); }));
            });
            var outputEvents = rxjs.merge.apply(void 0, __spreadArray([], __read(eventEmitters)));
            this.ngElementEventsSubscription = outputEvents.subscribe(function (subscription) {
                var customEvent = document.createEvent('CustomEvent');
                customEvent.initCustomEvent(subscription.name, false, false, subscription.value);
                _this.elementRef.nativeElement.dispatchEvent(customEvent);
            });
        };
        NgxElementComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.ngxElementService.getComponentToLoad(this.selector).subscribe(function (event) {
                _this.componentToLoad = event.componentClass;
                _this.componentFactoryResolver = _this.ngxElementService.getComponentFactoryResolver(_this.componentToLoad);
                _this.injector = _this.ngxElementService.getInjector(_this.componentToLoad);
                var attributes = _this.getElementAttributes();
                _this.createComponent(attributes);
            });
        };
        NgxElementComponent.prototype.createComponent = function (attributes) {
            this.container.clear();
            var factory = this.componentFactoryResolver.resolveComponentFactory(this.componentToLoad);
            this.refInjector = i0.ReflectiveInjector.resolveAndCreate([{ provide: this.componentToLoad, useValue: this.componentToLoad }], this.injector);
            this.componentRef = this.container.createComponent(factory, 0, this.refInjector);
            this.setAttributes(attributes);
            this.listenToAttributeChanges();
            this.setProxiedOutputs(factory);
        };
        NgxElementComponent.prototype.setAttributes = function (attributes) {
            var _this = this;
            attributes.forEach(function (attr) {
                _this.componentRef.instance[attr.name] = attr.value;
            });
        };
        NgxElementComponent.prototype.getElementAttributes = function () {
            var attrs = this.elementRef.nativeElement.attributes;
            var attributes = [];
            for (var attr = void 0, i = 0; i < attrs.length; i++) {
                attr = attrs[i];
                if (attr.nodeName.match('^data-')) {
                    attributes.push({
                        name: this.camelCaseAttribute(attr.nodeName),
                        value: attr.nodeValue
                    });
                }
            }
            return attributes;
        };
        NgxElementComponent.prototype.camelCaseAttribute = function (attribute) {
            var attr = attribute.replace('data-', '');
            var chunks = attr.split('-');
            if (chunks.length > 1) {
                return chunks[0] + chunks.slice(1).map(function (chunk) { return chunk.replace(/^\w/, function (c) { return c.toUpperCase(); }); }).join('');
            }
            return attr;
        };
        NgxElementComponent.prototype.listenToAttributeChanges = function () {
            var _this = this;
            var observer = new MutationObserver(function (mutations) {
                mutations.forEach(function (mutation) {
                    if (mutation.type === 'attributes') {
                        var attributes = _this.getElementAttributes();
                        _this.setAttributes(attributes);
                    }
                });
            });
            observer.observe(this.elementRef.nativeElement, {
                attributes: true
            });
        };
        NgxElementComponent.prototype.ngOnDestroy = function () {
            this.componentRef.destroy();
            this.ngElementEventsSubscription.unsubscribe();
        };
        return NgxElementComponent;
    }());
    NgxElementComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxElementComponent, deps: [{ token: NgxElementService }, { token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
    NgxElementComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: NgxElementComponent, selector: "lib-ngx-element", inputs: { selector: "selector" }, viewQueries: [{ propertyName: "container", first: true, predicate: ["container"], descendants: true, read: i0.ViewContainerRef }], ngImport: i0__namespace, template: "\n    <ng-template #container></ng-template>\n  ", isInline: true });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxElementComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-ngx-element',
                        template: "\n    <ng-template #container></ng-template>\n  ",
                        styles: []
                    }]
            }], ctorParameters: function () { return [{ type: NgxElementService }, { type: i0__namespace.ElementRef }]; }, propDecorators: { selector: [{
                    type: i0.Input
                }], container: [{
                    type: i0.ViewChild,
                    args: ['container', { read: i0.ViewContainerRef }]
                }] } });

    var NgxElementModule = /** @class */ (function () {
        function NgxElementModule(injector) {
            this.injector = injector;
            var ngxElement = elements.createCustomElement(NgxElementComponent, { injector: injector });
            customElements.define('ngx-element', ngxElement);
        }
        NgxElementModule.forRoot = function (modulePaths) {
            return {
                ngModule: NgxElementModule,
                providers: [
                    {
                        provide: LAZY_CMPS_PATH_TOKEN,
                        useValue: modulePaths
                    }
                ]
            };
        };
        NgxElementModule.prototype.ngDoBootstrap = function () { };
        return NgxElementModule;
    }());
    NgxElementModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxElementModule, deps: [{ token: i0__namespace.Injector }], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    NgxElementModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxElementModule, declarations: [NgxElementComponent] });
    NgxElementModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxElementModule });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: NgxElementModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [NgxElementComponent],
                        entryComponents: [NgxElementComponent]
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.Injector }]; } });

    /*
     * Public API Surface of ngx-element
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxElementModule = NgxElementModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-el.umd.js.map
