import { ComponentRef, OnInit, Type, ComponentFactoryResolver, OnDestroy, ElementRef, Injector, ReflectiveInjector } from '@angular/core';
import { NgxElementService } from './ngx-element.service';
import * as i0 from "@angular/core";
export declare class NgxElementComponent implements OnInit, OnDestroy {
    private ngxElementService;
    private elementRef;
    private ngElementEventsSubscription;
    selector: string;
    container: any;
    componentRef: ComponentRef<any>;
    componentToLoad: Type<any>;
    componentFactoryResolver: ComponentFactoryResolver;
    injector: Injector;
    refInjector: ReflectiveInjector;
    constructor(ngxElementService: NgxElementService, elementRef: ElementRef);
    /**
     * Subscribe to event emitters of a lazy loaded and dynamically instantiated Angular component
     * and dispatch them as Custom Events on the NgxElementComponent that is used in a template.
     */
    private setProxiedOutputs;
    ngOnInit(): void;
    createComponent(attributes: any): void;
    setAttributes(attributes: any): void;
    getElementAttributes(): any[];
    camelCaseAttribute(attribute: string): string;
    listenToAttributeChanges(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxElementComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxElementComponent, "lib-ngx-element", never, { "selector": "selector"; }, {}, never, never>;
}
//# sourceMappingURL=ngx-element.component.d.ts.map